function love.load()
    width = 400;
    height = 488;
  
    sound = true;
    
    state = "menu";
  
    -- always create sounds, fonts and images up here, NEVER DO IT IN UPDATE OR DRAW.
  
    love.window.setMode(width, height);
    love.window.setTitle("Floppy Box");
    
    icon = love.image.newImageData("assets/icon.jpg");
    love.window.setIcon(icon);

    love.graphics.setBackgroundColor(.26, .26, .36);
      -- background, always set it in love.load for higher efficiency as it's not drawing that on every second.
    
    score_font = love.graphics.newFont("assets/arial.ttf", 128);
    menu_font = love.graphics.newFont("assets/arial.ttf", 48);
    option_font = love.graphics.newFont("assets/arial.ttf", 24);
    
    -- a lesson on tables (lists,)
    -- example:
    -- list = {"angus, "edward"}
    -- table.insert(list, "alex");
    -- table.remove(list, "angus");
    
    jump_sound = love.audio.newSource("assets/jump.mp3", "static");
    -- the second part of this - "static" is good for short sound effects, and "stream" is better for actual music.
    
    
    -- for i = 1, 3 do
    --  this is a for loop, so run from 1 to 3. in lua stuff starts at 1. not 0.
    -- end
    
    drop = 375;
    jump_number = -220;
    
    boxX = 50;
    boxY = 220;
    gravity = 0;
    speed = 3.5;
    direction = "right";
    score = 0;
    
    add_speed = 0.175;
    
    safe = 10;
    safeLength = love.graphics.getHeight() - 10;
    
    high_score = loadData();
end



function loadButtons()
     if (state == "menu") then
           
      love.graphics.setColor(.5, .6, .5);
      love.graphics.rectangle("fill", 141, 180, 110, 30);
      love.graphics.rectangle("fill", 141, 215, 110, 30);
      love.graphics.rectangle("fill", 141, 250, 110, 30);
      
      love.graphics.setColor(1, 1, 1);
      love.graphics.setFont(option_font);
      love.graphics.print("Play", 172, 180);
      love.graphics.print("Controls", 152, 215);
      love.graphics.print("Exit", 172, 250);
     end
  
     if (state == "controls") then
          
          love.graphics.setColor(1, 1, 1);
          love.graphics.setFont(option_font);
          love.graphics.print("Space Bar/Click = Jump.", 91, 180);
          love.graphics.print("O - Go back to the menu.", 91, 210);
          love.graphics.print("M - Turn the sound off.", 91, 240);
          love.graphics.print("R - restart the game.", 91, 270);
          
     end
end



function loadData()
     return 0;
end



function saveData()
    
end



function love.keypressed(key) 
     if (key == "space") then
        if (state == "play") then
            jump();
        end
        
        if (state == "menu") then
            state = "play";
        end
     end
     
     if (key == "o") then
        restart();
        state = "menu";
     end
     
     if (key == "m") then
        if (sound == false) then 
            sound = true;
        else
            sound = false;
        end
     end
end



function jump()   
      if (state == "play") then
          gravity = jump_number;  
      
          if (sound == true) then
                love.audio.play(jump_sound);
          end
        
      end
end



function loadBoxes()
        safeLength = love.math.random(75, 125);
        safe = love.math.random(10, love.graphics.getHeight() - safeLength);
end


function increase()
       speed = speed + add_speed;
end

function love.update(dt)
    
    if (boxY < 23) then
          restart();
          gravity = gravity + (dt * drop);
    end
    
    if (boxY + (gravity * dt) > love.graphics.getHeight() - 45) then
          restart();
    else
          gravity = gravity + (dt * drop)
          boxY = boxY + (gravity * dt);
    end
    
    if (direction == "right" and state == "play") then
        if (boxX + speed > love.graphics.getWidth() - 40) then
              
            if (score == 0) then
              loadBoxes();
              score = score + 1;
              increase();
              direction = "left";
            else
              if (boxY <= safe or boxY >= (safe + safeLength)) then
                  print("BoxY: " .. tostring(boxY));
                  print("Safe: " .. tostring(safe));
                  print("Safe Length: " .. tostring(safeLength));
                  print("Safe + Length " .. tostring(safe + safeLength));
                  restart();
              else
                  loadBoxes();
                  score = score + 1;
                  increase();
                  direction = "left";
              end
              end

        else
            boxX = boxX + speed;
        end
    end
    
    if (direction == "left" and state == "play") then
        if (boxX - speed < 10) then
            
            if (score == 0) then
              loadBoxes();
              score = score + 1;
              increase();
              direction = "right";
            else
              if (boxY <= safe or boxY >= (safe + safeLength)) then
                  print("BoxY: " .. tostring(boxY));
                  print("Safe: " .. tostring(safe));
                  print("Safe Length: " .. tostring(safeLength));
                  print("Safe + Length " .. tostring(safe + safeLength));
                  restart();
              else
                  loadBoxes();
                  score = score + 1;
                  increase();
                  direction = "right";
              end
              end
            

              
        else
            boxX = boxX - speed;
        end
    end
    
    if (love.keyboard.isDown("escape")) then
        love.event.quit();
    end
    
    if (love.keyboard.isDown("r")) then
        restart();
    end
end


function start()
        score = 0;
        boxX = 50;
        boxY = 220;
        speed = 3.5;
        gravity = 0;
        direction = "right";
      
        state = "play";
        
        love.graphics.setColor(.8, 1, 0);
        love.graphics.rectangle("fill", love.graphics.getWidth() - 10, 
        love.math.random(10, love.graphics.getHeight() - 10), 10, 260);

end


function restart()
        if (score > high_score) then
            high_score = score;
        end
        
        score = 0;
        boxX = 50;
        boxY = 220;
        speed = 3.5;
        gravity = 0;
        direction = "right";
        
        love.graphics.setColor(.8, 1, 0);
        love.graphics.rectangle("fill", love.graphics.getWidth() - 10, 
        love.math.random(10, love.graphics.getHeight() - 10), 10, 260);
end



function love.mousepressed(x, y, button, pressed) 
      if (button == 1) then
          jump();
          
      love.graphics.rectangle("fill", 141, 180, 110, 30);
      love.graphics.rectangle("fill", 141, 215, 110, 30);
      love.graphics.rectangle("fill", 141, 250, 110, 30);
          
          if (state == "menu") then
               if (x >= 141 and x <= 251) then
                    if (y >= 180 and y <= 210) then
                         start();
                    end
                    
                    if (y >= 215 and y <= 245) then
                         state = "controls";
                    end
                    
                    if (y >= 250 and y <= 280) then
                         love.event.quit();
                    end
               end
          end
      end
end



function love.draw()
      loadButtons();
      
      love.graphics.setColor(.14, .36, .46);
      love.graphics.rectangle("fill", 0, 0, love.graphics.getWidth(), 20);
      love.graphics.rectangle("fill", 0, love.graphics.getHeight() - 20, love.graphics.getWidth(), 20);
      love.graphics.rectangle("fill", 0, 0, 10, love.graphics.getHeight());
      love.graphics.rectangle("fill", love.graphics.getWidth() - 10, 0, 10, love.graphics.getHeight());
      
      if (state == "play") then
              -- print the score in the background
      love.graphics.setColor(1, 1, 1);
      love.graphics.setFont(score_font);
      
      if (score < 10) then
          love.graphics.print("" .. score, love.graphics.getWidth() / 2 - 30, love.graphics.getHeight() / 2 - 100);    
      else if (score < 100) then
          love.graphics.print("" .. score, love.graphics.getWidth() / 2 - 65, love.graphics.getHeight() / 2 - 100);
      else if (score < 1000) then
          love.graphics.print("" .. score, love.graphics.getWidth() / 2 - 105, love.graphics.getHeight() / 2 - 100);
      else
         love.graphics.print("" .. score, love.graphics.getWidth() / 2 - 145, love.graphics.getHeight() / 2 - 100);
          end
        end
      end
    
      
      love.graphics.setColor(.60, .60, .10);
      love.graphics.rectangle("fill", boxX, boxY, 30, 25);
      
      if (score == 0) then
                love.graphics.rectangle("fill", love.graphics.getWidth() - 10, 20, 40, love.graphics.getHeight() - 40);
      else 
           if (direction == "right") then
                love.graphics.rectangle("fill", love.graphics.getWidth() - 10, safe, 40, safeLength);
            else
                love.graphics.rectangle("fill", 0, safe, 10, safeLength);
          end
          
                love.graphics.setColor(.14, .36, .46);
                love.graphics.rectangle("fill", 0, 0, love.graphics.getWidth(), 20);
                love.graphics.rectangle("fill", 0, love.graphics.getHeight() - 20, love.graphics.getWidth(), 20);
      end
      
    else if (state == "menu") then
            love.graphics.setFont(menu_font);
            love.graphics.setColor(1, 1, 1);
            love.graphics.print("Floppy Box", 82, 80);
            
            love.graphics.setFont(option_font);
            love.graphics.print("High Score: " .. high_score, 122, 140);
            
     else if (state == "controls") then
            love.graphics.setFont(menu_font);
            love.graphics.setColor(1, 1, 1);
            love.graphics.print("Controls", 112, 80);
       
      end
    end
  end  
end